diff --git a/gnu/packages/ocaml.scm b/gnu/packages/ocaml.scm
index 88c9241e205..a0004b6c4b0 100644
--- a/gnu/packages/ocaml.scm
+++ b/gnu/packages/ocaml.scm
@@ -128,7 +128,7 @@ (define-public camlboot
         (revision "1"))
     (package
       (name "camlboot")
-      (version (git-version "0.0.0" revision commit))
+      (version (make-git-version "0.0.0" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -2583,7 +2583,7 @@ (define-public ocaml-calendar
     (package
       (name "ocaml-calendar")
       ;; Makefile.in says 2.04.
-      (version (git-version "2.04" revision commit))
+      (version (make-git-version "2.04" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -2953,7 +2953,7 @@ (define-public ocaml-pyml
         (commit "e33f4c49cc97e7bc6f8e5faaa64cce994470642e"))
     (package
       (name "ocaml-pyml")
-      (version (git-version "20220905" revision commit))
+      (version (make-git-version "20220905" revision commit))
       (source
         (origin
          (method git-fetch)
@@ -5380,7 +5380,7 @@ (define-public bap
         (commit "f995d28a4a34abb4cef8e0b3bd3c41cd710ccf1a"))
     (package
       (name "bap")
-      (version (git-version "2.6.0-alpha" revision commit))
+      (version (make-git-version "2.6.0-alpha" revision commit))
       (home-page "https://github.com/BinaryAnalysisPlatform/bap")
       (source (origin
                 (method git-fetch)
@@ -5495,7 +5495,7 @@ (define-public ocaml-charinfo-width
   (let ((commit "20aaaa6dca8f1e0b1ace55b6f2a8ba5e5910b620"))
     (package
       (name "ocaml-charinfo-width")
-      (version (git-version "1.1.0" "1" commit))
+      (version (make-git-version "1.1.0" "1" commit))
       (home-page "https://github.com/kandu/charinfo_width/")
       (source (origin
                 (method git-fetch)
@@ -5747,7 +5747,7 @@ (define-public ocaml5.0-ctypes
      (package
        (inherit ocaml-ctypes)
        (name "ocaml-ctypes")
-       (version (git-version "0.20.1" revision commit))
+       (version (make-git-version "0.20.1" revision commit))
        (home-page "https://github.com/ocamllabs/ocaml-ctypes")
        (arguments
         (append
@@ -6544,7 +6544,7 @@ (define-public ocaml5.0-base
     (package
       (inherit ocaml-base)
       (name "ocaml-base")
-      (version (git-version "0.15.0" revision commit))
+      (version (make-git-version "0.15.0" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -6690,7 +6690,7 @@ (define-public ocaml-cinaps
         (revision "0"))
     (package
       (name "ocaml-cinaps")
-      (version (git-version "0.15.1" revision commit))
+      (version (make-git-version "0.15.1" revision commit))
       (home-page "https://github.com/ocaml-ppx/cinaps")
       (source
        (origin
@@ -7477,7 +7477,7 @@ (define-public ocaml5.0-ppx-expect
      (package
        (inherit ocaml-ppx-expect)
        (name "ocaml-ppx-expect")
-       (version (git-version "0.15.0" revision commit))
+       (version (make-git-version "0.15.0" revision commit))
        (source
         (origin
           (method git-fetch)
diff --git a/gnu/packages/ocr.scm b/gnu/packages/ocr.scm
index adb71bcc37e..21fcdaefe63 100644
--- a/gnu/packages/ocr.scm
+++ b/gnu/packages/ocr.scm
@@ -238,7 +238,7 @@ (define-public zinnia
   (let* ((commit "581faa8f6f15e4a7b21964be3a5ec36265c80e5b")
          (revision "1")
          ;; version copied from 'configure.in'
-         (version (git-version "0.07" revision commit)))
+         (version (vc-version "0.07" revision commit)))
     (package
       (name "zinnia")
       (version version)
diff --git a/gnu/packages/opencog.scm b/gnu/packages/opencog.scm
index 998d9b47ae5..69b9556ea80 100644
--- a/gnu/packages/opencog.scm
+++ b/gnu/packages/opencog.scm
@@ -40,7 +40,7 @@ (define-public cogutil
         (revision "1"))
     (package
       (name "cogutil")
-      (version (git-version "2.0.3" revision commit))
+      (version (make-git-version "2.0.3" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -72,7 +72,7 @@ (define-public atomspace
         (revision "1"))
     (package
       (name "atomspace")
-      (version (git-version "5.0.3" revision commit))
+      (version (make-git-version "5.0.3" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -114,7 +114,7 @@ (define-public cogserver
         (revision "2"))
     (package
       (name "cogserver")
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -152,7 +152,7 @@ (define-public attention
         (revision "1"))
     (package
       (name "attention")
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -197,7 +197,7 @@ (define-public opencog
         (revision "1"))
     (package
       (name "opencog")
-      (version (git-version "0.1.4" revision commit))
+      (version (make-git-version "0.1.4" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -248,7 +248,7 @@ (define-public agi-bio
         (revision "1"))
     (package
       (name "agi-bio")
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference